/*
  Turns CommonJS package into a browser file and minifies.
  
  uses node-jake http://github.com/mde/node-jake
  run with 'jake [build|minify|clean]'
*/
var fs = require("fs"),
    path = require("path"),
    sys = require("sys")
    build = require("./build");

task('build', [], function (dest) {
  sys.puts("building...");
  dest = dest || getPackage().name + ".js";
  build.build(dest);
  sys.puts("> " + dest);
});

task('minify', [], function (file, dest) {
  var name = getPackage().name;
  file = file || name + ".js";
  dest = dest || name + ".min.js";

  var minified = minify(fs.readFileSync(file, "utf-8"));
  fs.writeFileSync(dest, minified, "utf-8");
  sys.puts("> " + dest)
});

task('clean', [], function () {
  var name = getPackage().name;
  fs.unlink(name + ".js");
  fs.unlink(name + ".min.js");
});


function getPackage() {
  return JSON.parse(fs.readFileSync("package.json"));
}

function minify(code) {
  var uglifyjs = require("uglify-js"),
      parser = uglifyjs.parser,
      uglify = uglifyjs.uglify;

  var ast = parser.parse(code);
  ast = uglify.ast_mangle(ast);
  ast = uglify.ast_squeeze(ast);
  return uglify.gen_code(ast);
}
